<template>
    <div>
        <el-card class="el-card">
            <el-form :inline="true" :model="filterQuery" class="query-form" size="mini">
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.unitId"
                        placeholder="往来单位编码"
                        clearable
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.name"
                        placeholder="往来单位"
                        clearable
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.thirdSys" placeholder="请选择第三方系统" @change="thirdSysChange">
                        <el-option
                            v-for="item in thirdSys"
                            :key="item.value"
                            :label="item.thirdName"
                            :value="item.thirdId">
                            <span style="float: left">{{ item.thirdName }}</span>
                            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.thirdId }}</span>
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button-group style="display:flex;">
                        <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                        <el-button type="primary" icon="search" @click="getList">查询</el-button>
                        <el-button type="primary" icon="search" @click="clearAll"
                                   v-if="!this.thirdSysDetail.enabled">清空全部
                        </el-button>
                    </el-button-group>
                </el-form-item>
            </el-form>
            <el-table v-loading="loading" :data="list" style="width: 100%">
                <el-table-column label="序号" type="index" width="60"></el-table-column>
                <el-table-column label="往来单位ID" prop="id" width="100" show-overflow-tooltip></el-table-column>
                <el-table-column label="往来单位" prop="name" show-overflow-tooltip></el-table-column>
                <el-table-column label="拼音简写" prop="spell" width="100" show-overflow-tooltip></el-table-column>
                <el-table-column label="地址" prop="addr" show-overflow-tooltip></el-table-column>
                <el-table-column label="社会信用号" prop="creditNo" width="140" show-overflow-tooltip></el-table-column>
                <el-table-column label="联系人" prop="contact" width="100" show-overflow-tooltip></el-table-column>
                <el-table-column label="联系电话" prop="mobile" show-overflow-tooltip></el-table-column>
                <el-table-column label="操作" fixed="right"  v-if="thirdSysDetail.fromType!=0">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)"  :disabled="!delFalg"
                        >删除
                        </el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination
                :page-size="filterQuery.limit"
                @current-change="handleCurrentChange"
                layout="prev, pager, next"
                :total="total"
                :current-page="filterQuery.page"
            ></el-pagination>
        </el-card>
    </div>
</template>

<script>
import {
    getCorps, delCorps, delAll, downloadAll
} from "../../api/thrsys/thrCorps";
import {getBasicThirdSys, filterDetailByKey} from "../../api/basic/basicThirdSys";
import {ucloudUnit} from "../../api/basic/basicUnitMaintain";
import {selectIp} from "../../api/param/systemParamConfig";
import {findConfig} from "../../api/thrsys/spsSyncStatus";

export default {
    data() {
        return {
            filterQuery: {
                unitId: null,
                name: null,
                thirdSys: null,
                page: 1,
                limit: 20,
            },
            total: 0,
            list: [],
            thirdSys: [],
            thirdSysDetail: null,
            delFalg:true,
            uploadFileUrl: null,
            fileList: [],
            uploadData: {
                thirdSys: "thirdId",
            },
        };
    },

    methods: {
        onReset() {
            // this.$router.push({
            //     path: "",
            // });
            this.filterQuery = {
                unitId: null,
                name: null,
                thirdSys: null,
                page: 1,
                limit: 20,
            };
            this.getList();
        },

        getList() {


            if (this.filterQuery.thirdSys == null) {
                this.$message.warning("请先选择第三方系统！")
                return;
            }

            this.loading = true;
            ucloudUnit(this.filterQuery)
                .then((response) => {
                    if (response.code == 20000) {
                        this.list = response.data.list || [];
                        this.total = response.data.total || 0;
                    } else {
                        this.$message.error(response.message);
                    }
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        deleteDialog(row) {
            this.$confirm("此操作将永久删除该往来单位信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {

                    let dQuery = {
                        id: row.id,
                    };
                    delCorps(dQuery)
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.error(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },

        clearAll() {
            this.$confirm("此操作将清空所有往来单位信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    delAll()
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.success(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },
        getBasicThirdSys() {
            let query = {
                enabled: true,
            };
            getBasicThirdSys(query)
                .then((response) => {
                    this.thirdSys = response.data.list || [];
                    this.filterQuery.thirdSys = this.thirdSys[0].thirdId;
                    this.uploadData.thirdSys = this.filterQuery.thirdSys;
                    this.getThirdSysDetail();
                    this.selectSysParam();
                    this.getList();
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });
        },
        handleChange(response, files, fileList) {
            console.log(response);
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                this.$message.success("文件上传成功,请稍后刷新查看！");
            }
        },
        selectSysParam() {
            let query = {
                key: "thirdIpUrl",
                thirdSysFk: this.filterQuery.thirdSys
            };
            selectIp(query).then((response) => {
                if (response.code == 20000) {
                    this.uploadFileUrl = response.data.thridUrl + "/udiwms/erp/corp/upload";
                }
            });
        },
        thirdSysChange() {
            this.uploadData.thirdSys = this.filterQuery.thirdSys;
            this.getThirdSysDetail();
        },
        getThirdSysDetail() {
            let query = {
                thirdSysFk: this.filterQuery.thirdSys,
                key: "corpUrl",
            };
            filterDetailByKey(query)
                .then((response) => {
                    this.thirdSysDetail = response.data;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });

        },
        getConFig(){
                findConfig().then((response) =>{
                    if (response.code == 20000) {
                        this.delFalg=response.data.basicThirdCorp;
                    } else {
                        this.$message.error(response.message);
                    }
                });
            },
        downloadDatas() {
            let query = {
                thirdSysFk: this.filterQuery.thirdSys
            };
            downloadAll(query).then((response) => {
                if (response.code == 20000) {
                    this.$message.success(response.data);
                } else {
                    this.$message.error(response.message);
                }
            });

        },
    },
    components: {},
    mounted() {
    },
    created() {
        this.getConFig();
        this.getBasicThirdSys();
    },
};


</script>

<style scoped>

</style>
